<div id="canvas_container" bind:this={ containerEl }>
	{#each Array(totalPages) as x, idx}
		<div id="page-{ idx }" bind:this={ pagesEls[idx] }>
			{#if isRendering}
				<Loading />
			{/if}
			<canvas bind:this={ canvasEls[idx] }/>
		</div>
	{/each}
</div>

<script>
    import pdfjsLib from 'pdfjs-dist'
    import { TextLayerBuilder, EventBus } from 'pdfjs-dist/web/pdf_viewer.js'
    import 'pdfjs-dist/web/pdf_viewer.css'
	import { onMount } from 'svelte'
    import Loading from './Loading.svelte'
    
    pdfjsLib.GlobalWorkerOptions.workerSrc = 'https://cdn.jsdelivr.net/npm/pdfjs-dist@2.10.377/build/pdf.worker.min.js'
    
    // rw props
    export let pdfUrl // required
    export let zoom // required
    export let totalPages

    // r only props
    export let isRendering = true
	export let pagesEls = []

    // internal states
    let canvasEls = []
    let pdf
    let containerEl

    $: totalPages = pdf && pdf.numPages
    
	// if zoom change, re render
	$: zoom && totalPages && forceRender()

    export function forceRender() {
		isRendering = true
		// set as a macrotask to execute after disabledControls take effect
		setTimeout(async () => {
			await Promise.all(Array.from({length: totalPages}).map((_, idx) => renderPg(idx+1)))
			isRendering = false
		}, 0)
    }
    
	/* lifecycles */
	onMount(async () => {
        pdf = await pdfjsLib.getDocument(pdfUrl).promise
    })

    /* functions */
    function renderPg(pgNum) {
		return pdf.getPage(pgNum).then( async page => {
			// if canvasEls has not being binded yet, call to render this latter
			if (canvasEls.length < pgNum) return setTimeout(() => renderPg(num), 0)
			const pgEl = pagesEls[pgNum-1]
			const cvEl = canvasEls[pgNum-1]
			const ctx = cvEl.getContext('2d')
            const viewport = page.getViewport({ scale: 1 })
            const width = containerEl.getBoundingClientRect().width
            let scaledViewport = page.getViewport({
                scale: zoom * (width - 20) / viewport.width
            })

            if (width - 20 > viewport.width) {
                scaledViewport = page.getViewport({ scale: zoom }) 
            }

			cvEl.width = scaledViewport.width
			cvEl.height = scaledViewport.height

			await page.render({
				canvasContext: ctx,
				viewport: scaledViewport
            })

            // Get text-fragments
            const textContent = await page.getTextContent()
            
            // Create div which will hold text-fragments
            var textLayerDiv = document.createElement("div")

            // Set it's class to textLayer which have required CSS styles
            textLayerDiv.setAttribute("class", "textLayer");

            // Append newly created div in `div#page-#{pdf_page_number}`
            pgEl.appendChild(textLayerDiv);

            const eventBus = new EventBus()

            // Create new instance of TextLayerBuilder class
            var textLayer = new TextLayerBuilder({
                textLayerDiv: textLayerDiv, 
                pageIndex: page.pageIndex,
                viewport: scaledViewport,
                eventBus,
            });

            // Set text-fragments
            textLayer.setTextContent(textContent);

            // Render text-fragments
            return textLayer.render();
		})
	}
</script>

<style>
	*[id*="page-"] {
        width: fit-content;
		position: relative;
        box-shadow: 1px 1px 10px rgba(20, 20, 20, .7);
        margin: .6rem auto;
	}

	#canvas_container :global(.loader-spinner-container) {
		position: absolute;
		inset: 0;
		display: flex;
		align-items: center;
		justify-content: center;
		background: rgba(20, 20, 20, .45);
	}
</style>